#!/bin/bash

PHOTON_VERSION=1.0-SNAPSHOT

PHOTON_DIR=$(pwd)
PHOTON_CORE_DIR=${PHOTON_DIR}/photon-core

INSTALL_DIR=${PHOTON_DIR}/target/dev
INSTALL_BUNDLES_DIR=${INSTALL_DIR}/bundles
INSTALL_LIB_DIR=${INSTALL_DIR}/lib

RUNNER_BIN=${INSTALL_DIR}/photon-runner-${PHOTON_VERSION}.jar
MAVEN_LOG=${INSTALL_DIR}/maven.log

function install {
	if [ "$1" == 'login' ]; then
		other='game'
	fi
	if [ "$1" == 'game' ]; then
		other='login'
	fi

    # remove login or game bundle
	rm -f ${INSTALL_BUNDLES_DIR}/photon-${other}-${PHOTON_VERSION}.jar

	# compile and copy bundle (and its libraries)
	cd ${PHOTON_CORE_DIR}/photon-$1
	mvn compile package
	cp ./target/photon-$1-${PHOTON_VERSION}.jar ${INSTALL_BUNDLES_DIR}
	cp -rf ./target/lib/* ${INSTALL_LIB_DIR}

	# go back to install dir
	cd ${INSTALL_DIR}
}

# create photon installation
if [ ! -f ${RUNNER_BIN} ]; then
    # CREATE bundles/ and lib/ directories
    mkdir -p ${INSTALL_BUNDLES_DIR}
    mkdir -p ${INSTALL_LIB_DIR}
    touch ${MAVEN_LOG}
    touch ${INSTALL_DIR}/config.conf

    # compile and copy runner
    cd ${PHOTON_DIR}/photon-runner
    mvn clean install > ${MAVEN_LOG}
    cp ./target/photon-runner-${PHOTON_VERSION}.jar ${INSTALL_DIR}
	cp -rf ./target/lib/* ${INSTALL_LIB_DIR}
fi

install $1