package org.photon.core.login;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Module;
import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;
import org.photon.core.login.db.PhotonLoginDatabaseModule;
import org.photon.core.login.net.LoginNetworkService;
import org.photon.core.login.net.PhotonLoginNetworkModule;
import org.photon.core.login.net.game.LoginGameManager;
import org.photon.shared.kernel.Bundle;
import org.photon.shared.kernel.ServiceInterface;

/**
 * @author Blackrush
 */
public class PhotonLoginBundle extends Bundle {
    @Override
    public Iterable<Class<? extends Module>> getModules() {
        return modules(PhotonLoginNetworkModule.class, PhotonLoginDatabaseModule.class);
    }

    @Override
    public Iterable<Class<? extends ServiceInterface>> getServices() {
        return services(LoginNetworkService.class, LoginGameManager.class);
    }

    @Override
    public Config getDefaultParameters() {
        return ConfigFactory.parseMap(ImmutableMap.<String, Object>builder()
                .put("photon.login.network.laddr", "localhost:5555")
                .put("photon.login.network.game.laddr", "localhost:5556")
                .put("photon.login.client_version", "1.29.1")
                .put("photon.login.community", 0)
                .put("photon.login.db.digest_algorithm", "sha-512")
                .build());
    }
}
