package org.photon.core.login.db;

/**
 * @author Blackrush
 */
public abstract class AuthenticationException extends RuntimeException {
    private AuthenticationException(String message) {
        super(message);
    }

    private AuthenticationException(String message, Throwable cause) {
        super(message, cause);
    }

    public static final class InvalidCredentials extends AuthenticationException {
        public InvalidCredentials(Throwable cause) {
            super("invalid credentials", cause);
        }

        public InvalidCredentials() {
            this(null);
        }
    }

    public static final class Banned extends AuthenticationException {
        public Banned(Throwable cause) {
            super("banned", cause);
        }

        public Banned() {
            this(null);
        }
    }
}
