package org.photon.core.login.db;

import com.google.inject.Inject;

/**
 * @author Blackrush
 */
public final class User {
    private Long id;
    private String username;
    private String passwordHash;
    private String salt;
    private boolean banned;
    private String nickname;
    private String secretQuestion, secretAnswer;

    @Inject
    UserRepository repository;

    private boolean persisted;

    public User() {
    }

    public User(Long id, String username, String passwordHash, String salt, boolean banned, String nickname, String secretQuestion, String secretAnswer) {
        this.id = id;
        this.username = username;
        this.passwordHash = passwordHash;
        this.salt = salt;
        this.banned = banned;
        this.nickname = nickname;
        this.secretQuestion = secretQuestion;
        this.secretAnswer = secretAnswer;
    }

    public Long getId() {
        return id;
    }

    public User setId(Long id) {
        this.id = id;
        return this;
    }

    public String getUsername() {
        return username;
    }

    public User setUsername(String username) {
        this.username = username;
        return this;
    }

    public String getPasswordHash() {
        return passwordHash;
    }

    public User setPasswordHash(String passwordHash) {
        this.passwordHash = passwordHash;
        return this;
    }

    public String getSalt() {
        return salt;
    }

    public User setSalt(String salt) {
        this.salt = salt;
        return this;
    }

    public boolean isBanned() {
        return banned;
    }

    public User setBanned(boolean banned) {
        this.banned = banned;
        return this;
    }

    public String getNickname() {
        return nickname;
    }

    public User setNickname(String nickname) {
        this.nickname = nickname;
        return this;
    }

    public String getSecretQuestion() {
        return secretQuestion;
    }

    public User setSecretQuestion(String secretQuestion) {
        this.secretQuestion = secretQuestion;
        return this;
    }

    public String getSecretAnswer() {
        return secretAnswer;
    }

    public User setSecretAnswer(String secretAnswer) {
        this.secretAnswer = secretAnswer;
        return this;
    }

    public void persist() {
        repository.persist(this);
    }

    public boolean isPersisted() {
        return persisted;
    }

    void setPersisted(boolean persisted) {
        this.persisted = persisted;
    }

    public void remove() {
        repository.remove(this);
    }
}
