package org.photon.core.login.net;

import org.joda.time.Instant;
import org.photon.shared.event.EventDispatcher;
import org.photon.shared.kernel.ServiceInterface;

import java.util.Set;

/**
 * @author Blackrush
 */
public interface LoginNetworkService extends ServiceInterface {
    /**
     * @return the instant when this service has started or null if not started yet
     */
    Instant getStartInstant();

    /**
     * @return the set of all currently connected clients
     */
    Set<LoginClient> getConnectedClients();

    /**
     * @return the number of clients currently connected
     */
    int getCurrentConnectedClients();

    /**
     * @return the maximum number of clients connected in the same time
     */
    int getMaxConnectedClients();

    /**
     * @return the dispatcher used to handle client's (dis)connection and messages
     */
    EventDispatcher getDispatcher();
}
