package org.photon.core.login.net;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;

/**
 * @author Blackrush
 */
public final class SecureLoginKeyProvider implements LoginKeyProvider {
    public static final int KEY_LEN = 32, RADIX = 36, NUM_BITS = 164;

    private final Random random = new SecureRandom();

    @Override
    public String get() {
        return new BigInteger(NUM_BITS, random).toString(RADIX);
    }
}
