package org.photon.core.login.net.game;

import com.google.common.base.Function;
import org.photon.core.protocol.client.enums.WorldState;
import org.photon.core.protocol.client.types.GameServerType;

/**
 * @author Blackrush
 */
public interface LoginGameService {
    public static final Function<LoginGameService, GameServerType> TO_GAME_SERVER_TYPE = new Function<LoginGameService, GameServerType>() {
        public GameServerType apply(org.photon.core.login.net.game.LoginGameService input) {
            return input != null ? input.toGameServerType() : null;
        }
    };

    int getId();

    boolean isSync();
    String getLaddr();
    WorldState getState();
    boolean isJoinable();
    int getCompletion();

    GameServerType toGameServerType();
}
