package org.photon.core.protocol.client;

import org.photon.core.protocol.client.messages.GameServerSelectionMessage;
import org.photon.core.protocol.client.messages.PlayersListReqMessage;
import org.photon.core.protocol.client.messages.QueueReqMessage;
import org.photon.shared.collect.HashStringTree;
import org.photon.shared.collect.StringTree;

/**
 * @author Blackrush
 */
public final class Messages {
    private Messages() {}

    private static final StringTree<MessageFactory> fromClient;

    static {
        fromClient = HashStringTree.create();
        fromClient.put(QueueReqMessage.HEADER, QueueReqMessage.FACTORY);
        fromClient.put(PlayersListReqMessage.HEADER, PlayersListReqMessage.FACTORY);
        fromClient.put(GameServerSelectionMessage.HEADER, GameServerSelectionMessage.FACTORY);
    }

    public static StringTree<MessageFactory> fromClient() {
        return fromClient;
    }
}
