package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;
import org.photon.core.protocol.client.enums.ClientAuthErrorReason;

/**
 * @author Blackrush
 */
public class ClientAuthErrorMessage extends AbstractMessage {
    public static final String HEADER = "AlE";

    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new ClientAuthErrorMessage();
        }
    };

    private ClientAuthErrorReason reason;

    public ClientAuthErrorMessage() {
        super(HEADER);
    }

    public ClientAuthErrorMessage(ClientAuthErrorReason reason) {
        this();
        this.reason = reason;
    }

    public ClientAuthErrorReason getReason() {
        return reason;
    }

    public void setReason(ClientAuthErrorReason reason) {
        this.reason = reason;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(reason.value);
    }

    @Override
    public void deserialize(String input) {
        reason = ClientAuthErrorReason.forValue(input.charAt(HEADER.length()));
    }
}
