package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class ClientAuthMessage extends AbstractMessage {
    public static final String HEADER = "AlK";

    public static final MessageFactory FACTORY = new MessageFactory() {
        @Override
        public Message buildMessage() {
            return new ClientAuthMessage();
        }
    };

    private boolean hasRights;

    public ClientAuthMessage() {
        super(HEADER);
    }

    public ClientAuthMessage(boolean hasRights) {
        this();
        this.hasRights = hasRights;
    }

    public boolean hasRights() {
        return hasRights;
    }

    public void setRights(boolean hasRights) {
        this.hasRights = hasRights;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(hasRights ? '1' : '0');
    }

    @Override
    public void deserialize(String input) {
        hasRights = input.charAt(HEADER.length()) == '1';
    }
}
