package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;
import org.photon.core.protocol.client.enums.ClientAuthErrorReason;

/**
 * @author Blackrush
 */
public class ClientAuthVersionErrorMessage extends ClientAuthErrorMessage {
    public static final MessageFactory FACTORY = new MessageFactory() {
        @Override
        public Message buildMessage() {
            return new ClientAuthVersionErrorMessage();
        }
    };

    private String requiredVersion;

    public ClientAuthVersionErrorMessage() {
        super(ClientAuthErrorReason.INVALID_VERSION);
    }

    public ClientAuthVersionErrorMessage(String requiredVersion) {
        this();
        this.requiredVersion = requiredVersion;
    }

    public String getRequiredVersion() {
        return requiredVersion;
    }

    public void setRequiredVersion(String requiredVersion) {
        this.requiredVersion = requiredVersion;
    }

    @Override
    public void serialize(StringBuilder builder) {
        super.serialize(builder);
        builder.append(requiredVersion);
    }

    @Override
    public void deserialize(String input) {
        super.deserialize(input);
        requiredVersion = input.substring(HEADER.length() + 1);
    }
}
