package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class ClientVersionMessage extends AbstractMessage {
    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new ClientVersionMessage();
        }
    };

    private String version;

    public ClientVersionMessage(String version) {
        super("");
        this.version = version;
    }

    public ClientVersionMessage() {
        this("");
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(version);
    }

    @Override
    public void deserialize(String input) {
        version = input;
    }
}
