package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;
import org.photon.core.protocol.client.types.GameServerType;

/**
 * @author Blackrush
 */
public class GameServerMessage extends AbstractMessage {
    public static final String HEADER = "AX";

    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new GameServerMessage();
        }
    };

    private GameServerType server;

    public GameServerMessage() {
        super(HEADER);
    }

    public GameServerMessage(GameServerType server) {
        this();
        this.server = server;
    }

    public GameServerType getServer() {
        return server;
    }

    public void setServer(GameServerType server) {
        this.server = server;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER);
        server.serialize(builder);
    }

    @Override
    public void deserialize(String input) {
        server = new GameServerType();
        server.deserialize(input.substring(HEADER.length()));
    }
}
