package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class GameServerSelectionMessage extends AbstractMessage {
    public static final String HEADER = "AX";

    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new GameServerSelectionMessage();
        }
    };

    private int serverId;

    public GameServerSelectionMessage() {
        super(HEADER);
    }

    public GameServerSelectionMessage(int serverId) {
        this();
        this.serverId = serverId;
    }

    public int getServerId() {
        return serverId;
    }

    public void setServerId(int serverId) {
        this.serverId = serverId;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(serverId);
    }

    @Override
    public void deserialize(String input) {
        serverId = Integer.parseInt(input.substring(HEADER.length()));
    }
}
