package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class HelloConnectMessage extends AbstractMessage {
    public static final String HEADER = "HC";

    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new HelloConnectMessage();
        }
    };

    private String key;

    public HelloConnectMessage(String key) {
        super(HEADER);
        this.key = key;
    }

    public HelloConnectMessage() {
        this("");
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append("HC").append(key);
    }

    @Override
    public void deserialize(String input) {
        key = input.substring(HEADER.length());
    }
}
