package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class UserCommunityMessage extends AbstractMessage {
    public static final String HEADER = "Ac";

    public static final MessageFactory FACTORY = new MessageFactory() {
        @Override
        public Message buildMessage() {
            return new UserCommunityMessage();
        }
    };

    private int community;

    public UserCommunityMessage() {
        super(HEADER);
    }

    public UserCommunityMessage(int community) {
        this();
        this.community = community;
    }

    public int getCommunity() {
        return community;
    }

    public void setCommunity(int community) {
        this.community = community;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(community);
    }

    @Override
    public void deserialize(String input) {
        community = Integer.parseInt(input.substring(HEADER.length()));
    }
}
