package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;

/**
 * @author Blackrush
 */
public class UserCredentialsMessage extends AbstractMessage {
    private String username;
    private String passhash;

    public UserCredentialsMessage(String username, String passhash) {
        super("");
        this.username = username;
        this.passhash = passhash;
    }

    public UserCredentialsMessage() {
        this("", "");
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPasshash() {
        return passhash;
    }

    public void setPasshash(String passhash) {
        this.passhash = passhash;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(username).append('\n').append(passhash);
    }

    @Override
    public void deserialize(String input) {
        String[] args = input.split("\\n", 2);
        username = args[0];
        passhash = args[1];
    }
}
