package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class UserNicknameMessage extends AbstractMessage {
    public static final String HEADER = "Ad";

    public static final MessageFactory FACTORY = new MessageFactory() {
        @Override
        public Message buildMessage() {
            return new UserNicknameMessage();
        }
    };

    private String nickname;

    public UserNicknameMessage() {
        super(HEADER);
    }

    public UserNicknameMessage(String nickname) {
        this();
        this.nickname = nickname;
    }

    public String getNickname() {
        return nickname;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(nickname);
    }

    @Override
    public void deserialize(String input) {
        nickname = input.substring(HEADER.length());
    }
}
