package org.photon.core.protocol.client.messages;

import org.photon.core.protocol.client.AbstractMessage;
import org.photon.core.protocol.client.Message;
import org.photon.core.protocol.client.MessageFactory;

/**
 * @author Blackrush
 */
public class UserQuestionMessage extends AbstractMessage {
    public static final String HEADER = "AQ";

    public static final MessageFactory FACTORY = new MessageFactory() {
        public Message buildMessage() {
            return new UserQuestionMessage();
        }
    };

    private String question;

    public UserQuestionMessage() {
        super(HEADER);
    }

    public UserQuestionMessage(String question) {
        this();
        this.question = question;
    }

    public String getQuestion() {
        return question;
    }

    public void setQuestion(String question) {
        this.question = question;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(HEADER).append(question);
    }

    @Override
    public void deserialize(String input) {
        question = input.substring(HEADER.length());
    }
}
