package org.photon.core.protocol.client.types;

import com.google.inject.Provider;
import org.photon.core.protocol.client.Serializable;
import org.photon.core.protocol.client.enums.WorldState;

/**
 * @author Blackrush
 */
public class GameServerType implements Serializable {
    public static final Provider<GameServerType> PROVIDER = new Provider<GameServerType>() {
        public GameServerType get() {
            return new GameServerType();
        }
    };

    private int id;
    private String laddr;
    private WorldState state;
    private int completion;
    private boolean joinable;

    public GameServerType() {
    }

    public GameServerType(int id, String laddr, WorldState state, int completion, boolean joinable) {
        this.id = id;
        this.laddr = laddr;
        this.state = state;
        this.completion = completion;
        this.joinable = joinable;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getLaddr() {
        return laddr;
    }

    public void setLaddr(String laddr) {
        this.laddr = laddr;
    }

    public WorldState getState() {
        return state;
    }

    public void setState(WorldState state) {
        this.state = state;
    }

    public int getCompletion() {
        return completion;
    }

    public void setCompletion(int completion) {
        this.completion = completion;
    }

    public boolean isJoinable() {
        return joinable;
    }

    public void setJoinable(boolean joinable) {
        this.joinable = joinable;
    }

    @Override
    public void serialize(StringBuilder builder) {
        builder.append(id).append(';')
                .append(state.ordinal()).append(';')
                .append(completion).append(';')
                .append(joinable ? '1' : '0');
    }

    @Override
    public void deserialize(String input) {
        String[] data = input.split(";", 4);

        id = Integer.parseInt(data[0]);
        state = WorldState.valueOf(Integer.parseInt(data[1]));
        completion = Integer.parseInt(data[2]);
        joinable = data[3].equals("1");
    }
}
