package org.photon.shared.collect;

import java.util.Iterator;

/**
 * @author Blackrush
 */
public final class IterableStringAdapter implements Iterable<Character> {
    private final String string;

    public IterableStringAdapter(String string) {
        this.string = string;
    }

    @Override
    public Iterator<Character> iterator() {
        return new StringIterator();
    }

    public class StringIterator implements Iterator<Character> {
        private int index = 0;

        @Override
        public boolean hasNext() {
            return index < string.length();
        }

        @Override
        public Character next() {
            return string.charAt(index++);
        }

        @Override
        public void remove() {

        }
    }
}
