package org.photon.shared.collect;

/**
 * @author Blackrush
 */
public interface Tree<K, V> {
    Tree<K, V> getParent();
    Tree<K, V> getRoot();
    boolean hasChildren();

    public static interface Child<K, V> extends Tree<K, V> {
        K getKey();
        Iterable<K> getPath();
        V getValue();
        void setValue(V value);
    }

    Child<K, V> get(K key);
    V get(Iterable<K> keys);

    Child<K, V> put(K key, V value);
    Child<K, V> put(Iterable<K> keys, V value);

    V remove(K key);
    V remove(Iterable<K> keys);
}
