package org.photon.shared.kernel;

import static com.google.common.base.Preconditions.checkState;

/**
 * @author Blackrush
 */
public class AbstractService implements ServiceInterface {
    private State state;

    public AbstractService(State state) {
        this.state = state;
    }

    @Override
    public State getState() {
        return state;
    }

    protected void setState(State state) {
        this.state = state;
    }

    protected void setUp() {
    }

    protected void tearDown() {
    }

    @Override
    public void startUp() {
        checkState(state == State.LOADED);
        setUp();
        setState(State.STARTED);
    }

    @Override
    public void shutDown() {
        checkState(state == State.STARTED);
        tearDown();
        setState(State.STOPPED);
    }
}
