package org.photon.shared.kernel;

import com.google.common.collect.ImmutableSet;
import com.google.common.collect.Lists;
import com.google.inject.Module;
import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;

/**
 * @author Blackrush
 */
public abstract class Bundle {
    public abstract Iterable<Class<? extends Module>> getModules();

    public Config getDefaultParameters() {
        return ConfigFactory.empty();
    }

    public Iterable<Class<? extends ServiceInterface>> getServices() {
        return Lists.newArrayList();
    }

    public void load(BundleRegistry registry) {

    }

    public String getIdentifier() {
        return getClass().getPackage().getName();
    }

    @SafeVarargs
    public static Iterable<Class<? extends Module>> modules(Class<? extends Module>... modules) {
        return ImmutableSet.copyOf(modules);
    }

    @SafeVarargs
    public static Iterable<Class<? extends ServiceInterface>> services(Class<? extends ServiceInterface>... modules) {
        return ImmutableSet.copyOf(modules);
    }
}
