package org.photon.shared.kernel.event;

import org.photon.shared.kernel.ServiceInterface;
import org.photon.shared.kernel.State;

/**
 * @author Blackrush
 */
public final class ChangeStateEvent {
    private final ServiceInterface service;
    private final State newState;

    private ChangeStateEvent(ServiceInterface service, State newState) {
        this.service = service;
        this.newState = newState;
    }

    public static ChangeStateEvent create(ServiceInterface service, State newState) {
        return new ChangeStateEvent(service, newState);
    }

    public ServiceInterface getService() {
        return service;
    }

    public State getNewState() {
        return newState;
    }
}
