package org.photon.shared.collect;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.JUnit4;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.CoreMatchers.nullValue;
import static org.junit.Assert.assertThat;

/**
 * @author Blackrush
 */
@RunWith(JUnit4.class)
public class HashStringTreeTest {
    private StringTree<Integer> tree;

    @Before
    public void initTree() {
        tree = HashStringTree.create();
        tree.put("Hello, world!", 42);
        tree.put("Hello, Blackrush!", 18);
        tree.put("Hell NO!", 666);
    }

    @Test
    public void testGet() {
        assertThat(tree.get("Hello, world!"), is(42));
        assertThat(tree.get("Hello, Blackrush!"), is(18));
        assertThat(tree.get("Hell NO!"), is(666));

        assertThat(tree.get("Hello, world! some total crap here"), is(42));
        assertThat(tree.get("Hello, invalid key :)"), nullValue());

        assertThat(tree.get('H').getKey(), is('H'));
    }

    @Test
    public void testRemove() {
        assertThat(tree.remove("Hello, world!"), is(42));
        assertThat(tree.get("Hello, world!"), nullValue());
        assertThat(tree.remove("Hello, invalid key :)"), nullValue());
        assertThat(tree.get("Hello, Blackrush!"), is(18));
        assertThat(tree.remove("Hello, Blackrush! too long key"), nullValue());
    }
}
