package org.photon.shared.collect;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.JUnit4;

import java.util.Iterator;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

/**
 * @author Blackrush
 */
@RunWith(JUnit4.class)
public class IterableStringAdapterTest {
    private static final String INPUT = "Hello, world!";

    @Test
    public void test() {
        Iterable<Character> characters = new IterableStringAdapter(INPUT);
        Iterator<Character> it = characters.iterator();

        for (int i = 0; i < INPUT.length(); i++) {
            assertTrue(it.hasNext());
            assertThat(it.next(), is(INPUT.charAt(i)));
        }

        assertFalse(it.hasNext());
    }
}
