package org.photon.shared.inject;

import com.google.inject.Guice;
import com.google.inject.Injector;
import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.JUnit4;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;

/**
 * @author Blackrush
 */
@RunWith(JUnit4.class)
public class ConfigModuleTest {
    public static class TheClass {
        @InjectConfig("the.key")
        String the_field;
    }

    public static final String THE_VALUE = "test";

    private Injector inject;

    @Before
    public void setUp() {
        Config config = ConfigFactory.parseString("the.key=" + THE_VALUE);
        inject = Guice.createInjector(ConfigModule.of(config));
    }

    @Test
    public void testGetInstance() {
        TheClass theClass = inject.getInstance(TheClass.class);
        assertThat(theClass.the_field, is(THE_VALUE));
    }

    @Test
    public void testInjectMembers() {
        TheClass theClass = new TheClass();
        inject.injectMembers(theClass);
        assertThat(theClass.the_field, is(THE_VALUE));
    }
}
